searchNodes=[{"ref":"Double.html","title":"Double","type":"module","doc":"Double builds on-the-fly injectable dependencies for your tests. It does NOT override behavior of existing modules or functions. Double uses Elixir&#39;s built-in language features such as pattern matching and message passing to give you everything you would normally need a complex mocking tool for."},{"ref":"Double.html#allow/2","title":"Double.allow/2","type":"function","doc":"Adds a stubbed function to the given map, struct, or module. Structs will fail if they are missing the key given for function_name. Modules will fail if the function is not defined."},{"ref":"Double.html#allow/3","title":"Double.allow/3","type":"function","doc":""},{"ref":"Double.html#child_spec/1","title":"Double.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Double.html#clear/2","title":"Double.clear/2","type":"function","doc":"Clears stubbed functions from a double. By passing no arguments (or nil) all functions will be cleared. A single function name (atom) or a list of function names can also be given."},{"ref":"Double.html#double/0","title":"Double.double/0","type":"function","doc":"Returns a map that can be used to setup stubbed functions."},{"ref":"Double.html#double/2","title":"Double.double/2","type":"function","doc":"Same as double/0 but can return structs and modules too"},{"ref":"Double.html#init/1","title":"Double.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Double.html#stub/1","title":"Double.stub/1","type":"function","doc":""},{"ref":"Double.html#stub/3","title":"Double.stub/3","type":"function","doc":""},{"ref":"Double.html#t:allow_option/0","title":"Double.allow_option/0","type":"type","doc":""},{"ref":"Double.html#t:double_option/0","title":"Double.double_option/0","type":"type","doc":""},{"ref":"Double.Eval.html","title":"Double.Eval","type":"module","doc":"This is a simple GenServer that does a Code.eval_string while ignoring module conflict warnings. The need for a GenServer is to prevent two evaluations from executing simultaneously which has been observed to output the module conflict warnings due to the global nature of the setting."},{"ref":"Double.Eval.html#child_spec/1","title":"Double.Eval.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Double.Eval.html#eval/1","title":"Double.Eval.eval/1","type":"function","doc":""},{"ref":"Double.Eval.html#init/1","title":"Double.Eval.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Double.Eval.html#start_link/0","title":"Double.Eval.start_link/0","type":"function","doc":""},{"ref":"VerifyingDoubleError.html","title":"VerifyingDoubleError","type":"exception","doc":""},{"ref":"readme.html","title":"Double","type":"extras","doc":"Double Double builds on-the-fly injectable dependencies for your tests. It does NOT override behavior of existing modules or functions. Double uses Elixir&#39;s built-in language features such as pattern matching and message passing to give you everything you would normally need a complex mocking tool for."},{"ref":"readme.html#installation","title":"Double - Installation","type":"extras","doc":"The package can be installed as: Add double to your list of dependencies in mix.exs: def deps do [{:double, &quot;~&gt; 0.7.0&quot;, only: :test}] end"},{"ref":"readme.html#usage","title":"Double - Usage","type":"extras","doc":"Start Double in your test/test_helper.exs file: ExUnit.start Application.ensure_all_started(:double) Module/Behaviour Doubles Double creates a fake module based off of a behaviour or module. You can use this module like any other module that you call functions on. Each stub you define will verify that the function name and arity are defined in the target module or behaviour. defmodule Example do def process(io \\\\ IO) do # allow an alternative dependency to be passed io.puts(&quot;It works without mocking libraries!&quot;) end end defmodule ExampleTest do use ExUnit.Case import Double test &quot;example outputs to console&quot; do io_stub = stub(IO,:puts, fn(_msg) -&gt; :ok end) Example.process(io_stub) # inject the stub module # use built-in ExUnit assert_receive/refute_receive to verify things assert_receive({IO, :puts, [&quot;It works without mocking libraries!&quot;]}) end end"},{"ref":"readme.html#features","title":"Double - Features","type":"extras","doc":"Basics # Stub a function dbl = stub(ExampleModule, :add, fn(x, y) -&gt; x + y end) dbl.add(2, 2) # 4 # Pattern match arguments dbl = stub(Application, :ensure_all_started, fn(:logger) -&gt; nil end) dbl.ensure_all_started(:logger) # nil dbl.ensure_all_started(:something) # raises FunctionClauseError # Stub as many functions as you want dbl = ExampleModule |&gt; stub(:add, fn(x, y) -&gt; x + y end) |&gt; stub(:subtract, fn(x, y) -&gt; x - y end) Different return values for different arguments dbl = ExampleModule |&gt; stub(:example, fn(&quot;one&quot;) -&gt; 1 end) |&gt; stub(:example, fn(&quot;two&quot;) -&gt; 2 end) |&gt; stub(:example, fn(&quot;three&quot;) -&gt; 3 end) dbl.example(&quot;one&quot;) # 1 dbl.example(&quot;two&quot;) # 2 dbl.example(&quot;three&quot;) # 3 Multiple calls returning different values dbl = ExampleModule |&gt; stub(:example, fn(&quot;count&quot;) -&gt; 1 end) |&gt; stub(:example, fn(&quot;count&quot;) -&gt; 2 end) dbl.example(&quot;count&quot;) # 1 dbl.example(&quot;count&quot;) # 2 dbl.example(&quot;count&quot;) # 2 Exceptions dbl = ExampleModule |&gt; stub(:example_with_error_type, fn -&gt; raise RuntimeError, &quot;kaboom!&quot; end) |&gt; stub(:example_with_error_type, fn -&gt; raise &quot;kaboom!&quot; end) Verifying calls If you want to verify that a particular stubbed function was actually executed, Double ensures that a message is receivable to your test process so you can just use the built-in ExUnit assert_receive/assert_received. The message is a 3-tuple {module, :function, [arg1, arg2]}and . dbl = ExampleModule |&gt; stub(:example, fn(&quot;count&quot;) -&gt; 1 end) dbl.example(&quot;count&quot;) assert_receive({ExampleModule, :example, [&quot;count&quot;]}) Remember that pattern matching is your friend so you can do all kinds of neat tricks on these messages. assert_receive({ExampleModule, :example, [&quot;c&quot; &lt;&gt; _rest]}) # verify starts with &quot;c&quot; assert_receive({ExampleModule, :example, [%{test: 1}]) # pattern match map arguments assert_receive({ExampleModule, :example, [x]}) # assign an argument to x to verify another way assert x == &quot;count&quot; Module Verification By default your setups will check the source module to ensure the function exists with the correct arity. stub(IO, :non_existent_function, fn(x) -&gt; x end) # raises VerifyingDoubleError Clearing Stubs Occasionally it&#39;s useful to clear the stubs for an existing double. This is useful when you have a shared setup and a test needs to change the way a double is stubbed without recreating the whole thing. dbl = IO |&gt; stub(:puts, fn(_) -&gt; :ok end) |&gt; stub(:inspect, fn(_) -&gt; :ok end) # later dbl |&gt; clear(:puts) # clear an individual function dbl |&gt; clear([:puts, :inspect]) # clear a list of functions dbl |&gt; clear() # clear all functions"}]